"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unflattenRemoveArrayStateUpdate = exports.unflattenArrayStateUpdate = exports.unflatten = void 0;

var _getValue = _interopRequireDefault(require("./get-value"));

var _flat = require("flat");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var unflatten = function unflatten(path, value) {
  return (0, _flat.unflatten)(_defineProperty({}, "".concat(path), value), {
    object: true
  });
};

exports.unflatten = unflatten;

var unflattenArrayStateUpdate = function unflattenArrayStateUpdate(state, path, value) {
  var pathValue = (0, _getValue.default)(state, path);

  if (Array.isArray(pathValue)) {
    return unflatten("".concat(path, ".$push"), [value]);
  } else {
    return unflatten("".concat(path, ".$set"), [value]);
  }
};

exports.unflattenArrayStateUpdate = unflattenArrayStateUpdate;

var unflattenRemoveArrayStateUpdate = function unflattenRemoveArrayStateUpdate(path) {
  var pathSegments = path.split('.');
  var index = parseInt(pathSegments.pop(), 10);
  return unflatten("".concat(pathSegments.join('.'), ".$splice"), [[index, 1]]);
};

exports.unflattenRemoveArrayStateUpdate = unflattenRemoveArrayStateUpdate;